<?php
// Benutzername und Passwort für den Zugriff auf die Adminseite
$admin_username = 'admin';
$admin_password = 'Lena0308+'; // Sie sollten ein starkes Passwort verwenden

// Überprüfen, ob das Formular abgesendet wurde und die Benutzername-Passwort-Kombination korrekt ist
if (isset($_POST['username']) && isset($_POST['password'])) {
    $entered_username = $_POST['username'];
    $entered_password = $_POST['password'];

    // Überprüfen, ob Benutzername und Passwort korrekt sind
    if ($entered_username === $admin_username && $entered_password === $admin_password) {
        // Benutzername und Passwort korrekt, setze eine Session-Variable um den Zugriff zu markieren
        session_start();
        $_SESSION['admin_logged_in'] = true;
    } else {
        // Benutzername oder Passwort falsch
        echo "Falscher Benutzername oder Passwort.";
    }
}

// Überprüfen, ob der Administrator eingeloggt ist
session_start();
if (!isset($_SESSION['admin_logged_in']) || !$_SESSION['admin_logged_in']) {
    // Der Administrator ist nicht eingeloggt, zeige das Login-Formular
    ?>
    <!DOCTYPE html>
    <html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
		<link rel="icon" type="image/png" href="../img/logo.png">
        <link rel="stylesheet" href="../css/admin.css">
        <title>Login</title>
    </head>
    <body>
        <div class="login-container">
            <h2>Login</h2>
            <form class="login-form" method="post" action="">
                <label for="username">Benutzername:</label>
                <input type="text" id="username" name="username" required><br>
                <label for="password">Passwort:</label>
                <input type="password" id="password" name="password" required><br>
                <input type="submit" value="Login">
            </form>
        </div>
    </body>
    </html>
    <?php
    exit; // Stoppe die Ausführung des restlichen Codes, da der Benutzer nicht eingeloggt ist
}

// Überprüfen, ob die letzte Aktivitätszeit vorhanden ist und mehr als 15 Minuten vergangen sind
if (isset($_SESSION['last_activity'])) {
    $inactive_time = 15 * 60; // 15 Minuten in Sekunden
    $current_time = time();
    $elapsed_time = $current_time - $_SESSION['last_activity'];
    
    if ($elapsed_time > $inactive_time) {
        // Abmeldung des Benutzers aufgrund von Inaktivität
        session_unset();
        session_destroy();
        header("Location: logout.php"); // Leite den Benutzer zur Logout-Seite weiter
        exit;
    } else {
        // Aktualisiere die letzte Aktivitätszeit
        $_SESSION['last_activity'] = time();
    }
}

require_once '../vendor/autoload.php'; // Include barcode library

// Funktion zum Generieren des Barcodes
function generateBarcode($ean)
{
    // Überprüfen, ob die EAN gültig ist (nur Zahlen und Länge 13)
    if (ctype_digit($ean) && strlen($ean) == 13) {
        $generator = new Picqer\Barcode\BarcodeGeneratorHTML();
        return $generator->getBarcode($ean, $generator::TYPE_EAN_13);
    } else {
        return "Ungültige EAN";
    }
}

// Datenbankverbindung herstellen und Daten abrufen
$config = include '../config/config.php';
$conn = new mysqli($config['servername'], $config['username'], $config['password'], $config['database']);

if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

$sql = "SELECT * FROM articles";
$result = $conn->query($sql);
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
	<link rel="icon" type="image/png" href="../img/logo.png">
    <title>Admin</title>
    <link href="https://fonts.googleapis.com/css2?family=Roboto:wght@400;500;700&display=swap" rel="stylesheet">
    <link rel="stylesheet" href="../css/admin.css">
</head>
<body>
    <div class="container">
        <h2 class="table-title">Herdset Übersicht</h2>
        <table>
            <tr>
                <th>ID</th>
                <th>Hersteller</th>
                <th>Set Name</th>
                <th>Article Number</th>
                <th>EAN Barcode</th>
                <th>Backofen</th>
                <th>Backofen EAN</th>
                <th>Kochfeld</th>
                <th>Kochfeld EAN</th>
                <th>Auszug</th>
                <th>Auszug EAN</th>
                <th>Backblech</th>
                <th>Backblech EAN</th>
                <th>Pakete</th>
            </tr>
            <?php
            if ($result->num_rows > 0) {
                while($row = $result->fetch_assoc()) {
                    echo "<tr>";
                    echo "<td>" . $row["id"] . "</td>";
                    echo "<td>" . $row["manufacturer"] . "</td>";
                    echo "<td>" . $row["set_name"] . "</td>";
                    echo "<td>" . $row["article_number"] . "</td>";
                    echo "<td>" . generateBarcode($row["ean_barcode"]) . "</td>";
                    echo "<td>" . $row["part1"] . "</td>";
                    echo "<td>" . generateBarcode($row["part1_ean"]) . "</td>";
                    echo "<td>" . $row["part2"] . "</td>";
                    echo "<td>" . generateBarcode($row["part2_ean"]) . "</td>";
                    echo "<td>" . $row["part3"] . "</td>";
                    echo "<td>" . generateBarcode($row["part3_ean"]) . "</td>";
                    echo "<td>" . $row["part4"] . "</td>";
                    echo "<td>" . generateBarcode($row["part4_ean"]) . "</td>";
                    echo "<td>" . $row["quantity"] . "</td>";
                    echo "</tr>";
                }
            } else {
                echo "0 results";
            }
            $conn->close();
            ?>
        </table>
        <a href="../includes/add_article_form.php" class="add-article-button">Hinzufügen</a>
    </div>
</body>
</html>
